/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.bank.autostruct.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.springblade.bank.autostruct.entity.AutoStruct;
import org.springblade.bank.autostruct.service.IAutoStructService;
import org.springblade.bank.autostruct.vo.AutoStructVO;
import org.springblade.bank.autostruct.wrapper.AutoStructWrapper;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.system.service.IDeptService;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-09-23
 */
@RestController
@AllArgsConstructor
@RequestMapping("bank/autostruct")
@Api(value = "", tags = "接口")
public class AutoStructController extends BladeController {

	private final IAutoStructService autoStructService;
	private final IDeptService deptService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入autoStruct")
	public R<AutoStructVO> detail(AutoStruct autoStruct) {
		AutoStruct detail = autoStructService.getOne(Condition.getQueryWrapper(autoStruct));
		return R.data(AutoStructWrapper.build().entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入autoStruct")
	public R<IPage<AutoStructVO>> list(AutoStruct autoStruct, Query query) {
		QueryWrapper<AutoStruct> queryWrapper = Condition.getQueryWrapper(new AutoStruct());
		if (StringUtil.isNotBlank(autoStruct.getName())){
			queryWrapper.lambda().like(AutoStruct::getName, autoStruct.getName());
		}
		IPage<AutoStruct> pages = autoStructService.page(Condition.getPage(query), queryWrapper);
		return R.data(AutoStructWrapper.build().pageVO(pages));
	}


	/**
	 *
	 */
	@GetMapping("/getSelectAndPermissionByDept")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入autoStruct")
	public R getSelectAndPermissionByDept() {
		List<Map> mapList = new ArrayList<>();
		List<AutoStruct> list = autoStructService.list(new QueryWrapper<>(new AutoStruct()).lambda().like(AutoStruct::getDeptId, AuthUtil.getDeptId()));
		BladeUser user = AuthUtil.getUser();
		String userDeptId = AuthUtil.getDeptId();
		//多個角色問題
		String[] userRoles = user.getRoleId().split(",");

		list.forEach(item -> {
			Map<String, Object> map = new HashMap<>();
			Map<String, Object> map1 = BeanUtil.toMap(item);
			Map<String, Object> map2 = new HashMap<>();
//			map.put("tableStruct", item);
			String tableDeptIds = item.getDeptId();
			String tableRoleIds = item.getRoleId();
			boolean canWrite = tableDeptIds.contains(userDeptId);
			boolean roleFlag = false;

			boolean isManageRole = false;
			for (int i = 0; i < userRoles.length; i++) {
				String roleId = userRoles[i];
				isManageRole = isManageRole || item.getManageRoleId().contains(roleId);
				if (StringUtil.isNotBlank(tableRoleIds)){
					roleFlag = roleFlag || tableRoleIds.contains(roleId);
				}
			}
			if (StringUtil.isNotBlank(tableRoleIds)){
				canWrite = canWrite && roleFlag;
			}
			map2.put("isManageRole", isManageRole);
			map2.put("canWrite", canWrite);
			map.putAll(map1);
			map.putAll(map2);
			mapList.add(map);
		});
		return R.data(mapList);
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入autoStruct")
	public R<IPage<AutoStructVO>> page(AutoStructVO autoStruct, Query query) {
		IPage<AutoStructVO> pages = autoStructService.selectAutoStructPage(Condition.getPage(query), autoStruct);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入autoStruct")
	public R save(@Valid @RequestBody AutoStruct autoStruct) {
		return R.status(autoStructService.save(autoStruct));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入autoStruct")
	public R update(@Valid @RequestBody AutoStruct autoStruct) {
		return R.status(autoStructService.updateById(autoStruct));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入autoStruct")
	public R submit(@Valid @RequestBody AutoStruct autoStruct) {
		return R.status(autoStructService.saveOrUpdate(autoStruct));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(autoStructService.deleteLogic(Func.toLongList(ids)));
	}


}
